﻿using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CASE_183309
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<TestData> testData = null;
        public MainWindow()
        {
            InitializeComponent();

            testData = new ObservableCollection<TestData>();


            for (int j = 0; j < 10; j++)
            {
                TestData e = new TestData { Check = false, Id = j, Test1 = "test" + j, Test2 = "test" + j };

                ObservableCollection<TestData>  cData = new ObservableCollection<TestData>();
                cData.Add(new TestData { Id = j, Test1 = "test", Test2 = "test" });

                e.TestDataList = cData;
               testData.Add(e);
            }

            this.DataContext = testData;

            this.MyGrid.ExpansionIndicatorSettings.Visibility = Visibility.Hidden;
        }

        private void TextBlock_MouseDown(object sender, MouseButtonEventArgs e)
        {
            CellControl cell = Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject, typeof(CellControl), true) as CellControl;
            (cell.Cell.Row as Row).IsExpanded = !(cell.Cell.Row as Row).IsExpanded;
        }
    }

    public class TestData : INotifyPropertyChanged
    {
        private bool m_check;
        public bool Check
        {
            get { return m_check; }
            set
            {
                m_check = value;
                NotifyPropertyChanged("Check");
            }
        }

        private int m_id;
        public int Id
        {
            get { return m_id; }
            set
            {
                m_id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private String m_test1;
        public String Test1
        {
            get { return m_test1; }
            set
            {
                m_test1 = value;
                NotifyPropertyChanged("Test1");
            }
        }

        private String m_test2;
        public String Test2
        {
            get { return m_test2; }
            set
            {
                m_test2 = value;
                NotifyPropertyChanged("Test2");
            }
        }

        private ObservableCollection<TestData> m_testDataList;
        public ObservableCollection<TestData> TestDataList
        {
            get { return m_testDataList; }
            set
            {
                m_testDataList = value;
                NotifyPropertyChanged("TestDataList");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
